window.gameStorage = {

    readCookie: function(key) {
        var data = document.cookie;
        var idx = data.indexOf(key + "=");
        if (idx != -1) {
            idx= idx + key.length + 1;
            var idx2 = data.indexOf(";", idx);
            return idx2 != -1 ? data.substring(idx, idx2) : data.substring(idx);
        }
        return undefined;
    },

    getLocal: function(key, isJson) {
        try {
            if (typeof localStorage == undefined) {
                var data = window.gameStorage.readCookie(key);
                return isJson && data ? JSON.parse(data) : data;
            }
            var data = localStorage.getItem(key);
            return isJson && data ? JSON.parse(data) : data;
        } catch (exception) {
            return undefined;
        }
    },

    saveLocal: function(key, value, isJson) {
        try {
            var value = isJson ? JSON.stringify(value) : value;
            if (typeof localStorage == undefined) {
                document.cookie = key + "=" + value;
            } else {
                localStorage.setItem(key, value);
            }
        } catch (exception) {
            window[key] = value;
            return;
        }
    },

    // Not used, so far as I can tell.
    deleteLocal: function(key) {
        try {
            if (typeof localStorage == undefined) {
                document.cookie = key + "=";
            } else {
                localStorage.removeItem(key);
            }
        } catch (exception) {
            return;
        }
    },
};
